# -*- coding: utf-8 -*-
"""llama_test.ipynb

Automatically generated by Colab.

Original file is located at
    https://colab.research.google.com/drive/1xo-TYkfheYceA5IcNxJ6FwQaTeVZMqAe
"""

import os


repository_url = "https://git.miem.hse.ru/nauchpok/Nauchpok.git"
repository_name = "Nauchpok"

# Клонирование репозитория
!git clone "{repository_url}"

# Переход в папку репозитория
os.chdir(repository_name)

# Настройка имени пользователя и email (важно для коммитов)
!git config user.email "aipodolskii@edu.hse.ru"
!git config user.name "Андрей Подольский"

branch_name = "Подольский-patch-aiintegration"

!git pull origin develop
!git checkout -b "{branch_name}" develop

import os
import requests
from google.colab import userdata
hyperbolic_api_key = userdata.get('HYPERBOLIC')


def search_articles_llama(query):

    url = "https://api.hyperbolic.xyz/v1/chat/completions"
    headers = {
        "Content-Type": "application/json",
        "Authorization": f"Bearer {hyperbolic_api_key}"
    }
    data = {
        "messages": [
            {
                "role": "user",
                "content": f"Найди 5 наиболее релевантных научных статей по запросу: {query}. Для каждой статьи укажи название,  авторов,год(в конце добавляю букву г), и количество цитирований. Просто перечисли их в следующем формате: Название (Авторы, Год, Количество цитирований) - каждая статья с новой строки, не давай вводных фраз и комментариев.Эти запросы отсортируй от наибольшего до наименьшего по числу года! Все ответы давай на русском"


            }
        ],
        "model": "meta-llama/Llama-3.3-70B-Instruct",
        "max_tokens": 512,
        "temperature": 0.1,
        "top_p": 0.9
    }

    try:
        response = requests.post(url, headers=headers, json=data)
        response.raise_for_status()

        response_json = response.json()
        if 'choices' in response_json and len(response_json['choices']) > 0:
            article_titles = response_json['choices'][0]['message']['content'].strip().split('\n')
            return article_titles
        else:
            print("Предупреждение: Не удалось получить список статей.")
            return []
    except requests.exceptions.RequestException as e:
        print(f"Ошибка при запросе к API Hyperbolic: {e}")
        return [] # Возвращаем пустой список в случае ошибки


# ------------------------------------------------------------
# Функция для отображения результатов (без изменений)

def display_results(articles, query):
    """Отображает результаты поиска."""
    if not articles:
        print(f"По запросу '{query}' ничего не найдено.")
        return

    print(f"Результаты поиска по запросу: '{query}'")
    for i, title in enumerate(articles):
        print(f"{i+1}. {title}")
    print("-" * 5)



# Список поисковых запросов

search_queries = [
    "Последние достижения в исследованиях рака",
    "Влияние изменения климата на биологию",
    "Новые разработки в области искусственного интеллекта",
    "Новшества в кибернетике",
    "Редактирование генов"
]


# Запуск поиска для каждого запроса

print("Запуск поиска научных статей с использованием Llama-3.3-70B (через Hyperbolic):")
for query in search_queries:
    results = search_articles_llama(query)
    display_results(results, query)

print("Тестирование окончено.")

"""**Llama-3.3-70B.**
Последняя БЯМ меты, на сайте по сути бесплатно доступно 2.5 мил токенов, макс ставил на ответ в 512. С задачей сортировки по году нормально сразу справился.*Semantic Scholar* и *Google Scholar* - по сути могут быть лучше, тк специализированы, но к ним не удается получить ключи. Также думаю, что можно подключить более хитрые и специализированые а-ля *Mendeley*(1-ая лекция по предмету), но там вроде как проблема что каждый должен будет получать токен и авторизовываться(если я все правильно понял). БТВ это обсуждаемо, но на мой взгляд лучше использовать общую ИИ, нежели узконаправленную.

"""

!git status
!git add .
!git commit
!git push  origin "{branch_name}"
!git remote set-url origin https://oauth2:7ysijzPoRBzMfFfJrbSa@git.miem.hse.ru/nauchpok/Nauchpok.git
!git pull origin develop
!ping git.hse.miem.ru

