from speechkit import model_repository, configure_credentials, creds
from speechkit.stt import AudioProcessingType
from dotenv import dotenv_values

config = dotenv_values()

key = config['speechkit_stt']
configure_credentials(
    yandex_credentials=creds.YandexCredentials(
        api_key=key
    )
)

model = model_repository.recognition_model()

model.model = 'general'
model.language = 'ru-RU'
model.audio_processing_type = AudioProcessingType.Full

result = model.transcribe_file('stt/test.ogg')
for c, res in enumerate(result):
    print(f'channel: {c}\n'
          f'raw_text: {res.raw_text}\n'
          f'norm_text: {res.normalized_text}\n')
